// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.QNDocMan;

import com.qanavigation.QNservices.QNDBacc2;

/**
 * RT Edit Frame Base Object
 * @author RGDM2
 *
 */
public class RTEditFrmObj extends RTFrameObj {
	
	public boolean m_statIsDraft;
	public boolean m_roleIsYours;
	
	public String m_assignee;
	public String m_stat;
	public String m_UID;
	
	public QNDocMan m_qnDm;

	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 * @param p_RepType
	 */
	public RTEditFrmObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc, String p_RepType ) {
		
		super( p_Srvl, p_Request, p_dBAcc );
		
		initMe( p_RepType );
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "RTEditFrmObj", "RTEditFrmObj", "", "" );
		}
	}
	
	// ------------------
	private void initMe( String p_RepType ) {
		
		m_assignee = "";
		m_stat = "";
		
		m_statIsDraft = false;
		m_roleIsYours = true;
		
		m_UID = m_sTools.getStrVal( "UID" );
		
		m_qnDm = new QNDocMan( m_dBAcc.m_DB, p_RepType );
		
		if( m_UID.length() > 0 ) {

			m_assignee = m_qnDm.getAssignee( m_UID ).getString();
	
			if( ( m_User.compareTo( m_assignee ) != 0) ) {
	
				m_roleIsYours = false;
			}
			
			m_stat = m_qnDm.getDocStat( m_UID ).getString();
			
			if( ( m_stat.length() == 0 ) || ( m_stat.compareTo( "dr" ) == 0 ) ) {
				
				m_statIsDraft = true;
			}
		}
		else {
			
			m_statIsDraft = true;
		}
	}
}
