// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.CRRepStat;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * CR Report Edit Object
 * @author RGDM2
 *
 */
public class RepCRObj extends CRRepObj {

	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 */
	public RepCRObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {

		super( p_Srvl, p_Request, p_dBAcc );
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "RepCRObj", "RepCRObj", "", "" );
		}
	}
	
	// ------------------
	private Rslt handleEdit( ) {

		Rslt res = new Rslt( true );
		
		RsltString rVal;
		
		String author;
		String msg;
		
		if( res.checkRslt( m_UID ) ) {

			res = m_crb.loadCRData( m_UID.getString() );
		}
		
		if( res.isOK() ) {

			rVal = m_sTools.getVal( "Author" );

			author = rVal.getString();

			if( m_User.compareTo( author ) != 0 ) {

				msg = SFormatter.format( m_resBndl.getString( "msgLastAuthorWas" ), author );  

				m_crb.appProcLogX( m_UID.getString(), msg );
			}
		}
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "CRObj.handleEdit() failed." );
		}

		return res;
	}
	
	/**
	 * 
	 * @return
	 */
	public Rslt initObj() {
		
		boolean isSub;
		
		String QNA;
		
		Rslt res = new Rslt( true );
		
		RsltString rVal; 
		
		isSub = false;
		
		m_modeIsUpl = false;
		m_modeIsDel = false;
		m_modeIsEdit = false;
		m_isHandled = false;

		if( isOK() ) {
			
			// Checking the request
			QNA = m_sTools.getStrVal( "QNA" );
			
			m_UID = m_sTools.getVal( "UID" );

			if( 0 == QNA.compareTo( "RepCR" ) ) {
				
				m_isHandled = true;
			}
		
			if( !( m_isHandled ) ) {

				if( 0 == QNA.compareTo( "UplCR" ) ) {
	
					m_isHandled = true;
					m_modeIsUpl = true;
					m_statIsDraft = true;
				}
			}
			
			if( !( m_isHandled ) ) {

				if( 0 == QNA.compareTo( "DelFile" ) ) {

					m_isHandled = true;
					m_modeIsDel = true;
					m_statIsDraft = true;
				}
			}
			
			if( !( m_isHandled ) ) {

				if( 0 == QNA.compareTo( "EditCR" ) ) {

					m_isHandled = true;
					m_modeIsEdit = true;						
				}
			}
			
			if( !( m_isHandled ) ) {
				
				res.setInError( "Unknown request '" + QNA + "'." );
			}
		}
		
		if( res.isOK() && ( m_modeIsUpl || m_modeIsDel || m_modeIsEdit ) ) {

			//out.println( "<p>Retrieving the appended files.</p>" );

			m_RepStat = m_crb.getVal( QNDefs.c_AttrCRStat );
			
			if( m_RepStat.length() < 1 ) {
				
				m_RepStat = getRepStat( QNDefs.c_AttrCRStat );
			}
		
			CRRepStat statObj = new CRRepStat( m_RepStat );
				
			isSub = statObj.isSub();
			m_modeIsEdit2 = statObj.nextEdit2( true );
			
			if( m_modeIsEdit2 ) {
				
				m_ro = " readonly=\"true\"";
				m_cRo = "class=\"ro\" ";
			}
		}		
		
		// Building the Report ------
		if( res.isOK() && m_modeIsDel ) {

			res = handleDelFile();
		}

		if( res.isOK() && (m_modeIsDel || m_modeIsUpl )) {
			
			rVal = handleSave( m_statIsDraft, isSub );
			m_UID = rVal;
		}
			
		if( res.isOK() && m_modeIsEdit ) {
			
			res = handleEdit();
		}		
		
		if( res.notOK() ) {
			
			res.addRsltAddInfo( "CRObj.initObj() failed." );
		}
		
		return res;
	}
}
