/*
 * piQa Services Collection
 * Created on Apr 23, 2005
 * Copyright � 2005 Ronald D. Grindle
 */
package RTObj;

import com.qanavigation.Basics.BTools;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SetList;
import com.qanavigation.QNservices.QNDefs;
import com.qanavigation.QNservices.QNRepBld;
import com.qanavigation.QNservices.SrvltReqTools;
import com.qanavigation.XMLBasics.RsltXMLDoc;
import com.qanavigation.XMLBasics.RsltXMLNode;
import com.qanavigation.XMLDB.XMLDB;

/**
 * Fix Document Builder
 */
public class ShpDocBld extends QNRepBld {
	
	//private XMLDB m_xDB;
	//private RsltXMLDoc m_xDoc;
	private RsltXMLNode m_slLstNode;
	
	//-------------------------------------
	public ShpDocBld( XMLDB p_xDB, SrvltReqTools p_SRT, String p_FilePath ) {
		
		super( p_xDB, p_SRT, p_FilePath, QNDefs.c_NodeShpDoc );
		
		m_slLstNode = null;
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "ShpDocBld", "ShpDocBld", "1", "" );
		}
		
		// used to signal that the list ist not set setRsltStat(  RsltStatVal.isEmpty  );
	}

	/**
	 * Builds a shipment document for several fixes.
	 * @param p_Author
	 * @param p_Appl
	 * @param p_Release
	 * @param p_ShipDate
	 * @return
	 */
	public Rslt bldShpLstDoc( String p_Author, String p_Appl, String p_Release, String p_ShipDate, String p_Cmnt ) {
		
		Rslt res = new Rslt( true );
		
		RsltXMLNode slNode;

		String dt;
	
		/*
			<!ELEMENT ShpDoc ( Cmnt?, ShpLst*)>
				<!ATTLIST ShpDoc
					Appl					NMTOKEN #IMPLIED
					Author				CDATA #IMPLIED
					Assignd				CDATA #IMPLIED
					Cmnt					CDATA #IMPLIED
					DateTime			NMTOKEN #REQUIRED
					DateTimeShip	NMTOKEN #IMPLIED
					ShipProcStat	NMTOKEN #IMPLIED
					ShipRel				NMTOKEN #IMPLIED
					ShipStat			NMTOKEN #REQUIRED
					TstSys				NMTOKEN #IMPLIED
					UID						NMTOKEN #IMPLIED
				>								
		*/

		try {
			
			m_xDoc = new RsltXMLDoc( "", QNDefs.c_NodeShpDoc, QNDefs.c_ShpLstDTD, null );
				
			if( res.checkRslt( m_xDoc ) ) {
				
				slNode = m_xDoc.getTopNode();
		
				//<?xml version="1.0"?>
				//FXNode.createXmlDecl( "1.0", "", "" );
	
				//<!-- Generated by QA Navigator Fix Proc... -->
				String genCom = QNDefs.c_PhrGenBy + this.getClass().getName();
				slNode.addComment( genCom );
		
				slNode.addAttrAsHTML( QNDefs.c_AttrAuthor, p_Author );
				slNode.addAttrAsHTML( QNDefs.c_AttrAssignd, p_Author );
					
				dt = BTools.getNowISODateTimeSec();
				
				slNode.addAttrAsHTML( QNDefs.c_AttrCmnt, p_Cmnt );
					
				slNode.addAttribute( QNDefs.c_AttrDateTime, dt );
		
				slNode.addAttrAsHTML( QNDefs.c_AttrAppl, p_Appl );
				slNode.addAttrAsHTML( QNDefs.c_AttrShipRel, p_Release );
				slNode.addAttribute( QNDefs.c_AttrShpStat, QNDefs.c_StatNew );
				slNode.addAttrAsHTML( QNDefs.c_AttrDateTimeShip, p_ShipDate );				
				
				m_slLstNode = slNode.appNode( QNDefs.c_NodeShpLst );
				
				setOK();
			}
		}
		catch( Exception excp ) {
			
			res.setRsltByExcp( excp );
			setRsltStat( res );
		}
							
		return res;
	}

	/**
	 * Builds the subtree into the given node.
	 * @param p_SprNode
	 * @param p_UidPR
	 * @param p_RightStat
	 * @return
	 */
	public Rslt bldSol( RsltXMLNode p_SprNode, String p_UidPR, String p_RightStat )  {	

		int i, x, k, y;
		
		RsltString rStr;		
		
		RsltXMLNode sfeNode;
		RsltXMLNode sfrNode;		
		
		SetList uidLst;
		SetList uidFixLst;
		SetList uidFixEntLst;
		
		String fixUid;		
		String uid;	
		
		String fixTitle;

		String rUid = "";
		String val;

		Rslt res = new Rslt( true );
		
		// The fix is already set to the new status!!!
		/*
		<!ELEMENT ShpLst (ShpPRRef*)>
			<!ATTLIST ShpLst
				UID				NMTOKEN #IMPLIED
			>
		<!ELEMENT ShpPRRef (ShpFixRef*)>
			<!ATTLIST ShpPRRef
				ExtID		NMTOKEN #IMPLIED			
				RefUID		NMTOKEN #REQUIRED
				Ticket		NMTOKEN #IMPLIED
				Title		CDATA #REQUIRED
				UID			NMTOKEN #IMPLIED
			>
		<!ELEMENT ShpFixRef (ShpFixEntry*)>
			<!ATTLIST ShpFixRef
				RefUID		NMTOKEN #REQUIRED
				Title			CDATA #REQUIRED
				UID				NMTOKEN #IMPLIED
			>
	
		<!ELEMENT ShpFixEntry (EMPTY)>
			<!ATTLIST ShpFixRef
				DateTime	NMTOKEN #REQUIRED
				Name			NMTOKEN #REQUIRED
				Path			NMTOKEN #IMPLIED
				Rel				NMTOKEN #IMPLIED
				SrcSrv		NMTOKEN #IMPLIED
				UID				NMTOKEN #IMPLIED
			>
		*/
		try {

			rStr = m_xDB.getAttrVal( p_UidPR, QNDefs.c_AttrExtID );
			
			p_SprNode.addAttribute( QNDefs.c_AttrExtID, rStr.getString() );			
			
			rStr = m_xDB.getAttrVal( p_UidPR, QNDefs.c_AttrTicket );
			
			p_SprNode.addAttribute( QNDefs.c_AttrTicket, rStr.getString() );		
		
			rStr = m_xDB.getAttrVal( p_UidPR, QNDefs.c_AttrTitle );
			
			p_SprNode.addAttribute( QNDefs.c_AttrTitle, rStr.getString() );
			
			p_SprNode.addAttribute( QNDefs.c_AttrRefUID, p_UidPR );				
			
			// The fix list --------------
			uidLst = m_xDB.getUIDLstByParent( QNDefs.c_NodeRefFix, p_UidPR );
				
			if( res.checkRslt( uidLst, true ) ) {
					
				x = uidLst.size();
					
				for( i = 0; i < x; ++i ) {
						
					uid = uidLst.getString( i );
					
					// the Fix
					rStr = m_xDB.getAttrVal( uid, QNDefs.c_AttrRefUID );
					fixUid = rStr.getString();
					
					if( fixUid.length() > 0 ) {
						
						rStr = m_xDB.getAttrVal( fixUid, QNDefs.c_AttrFixStat );								
													
						if( rStr.getString().compareTo( p_RightStat ) == 0 ) {								
						
							sfrNode = p_SprNode.appNode( QNDefs.c_NodeShpFixRef );
							
							rStr = m_xDB.getAttrVal( fixUid, QNDefs.c_AttrTitle );
							fixTitle = rStr.getString();
							
							sfrNode.addAttribute( QNDefs.c_AttrTitle, fixTitle );		
							sfrNode.addAttribute( QNDefs.c_AttrRefUID, fixUid );								
		
							uidFixLst = m_xDB.getUIDLstByParent( QNDefs.c_NodeFixLst, fixUid );
							
							if( uidFixLst.size() > 0 ) {
							
								uid = uidFixLst.getString( 0 );
								
								uidFixEntLst = m_xDB.getUIDLstByParent( QNDefs.c_NodeFixEnt, uid );
								
								y = uidFixEntLst.size();
								
								for( k = 0; k < y; ++k ) {
			
									rUid = uidFixEntLst.getString( k );
									
									sfeNode = sfrNode.appNode( QNDefs.c_NodeShpFixEnt );
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrAuthor );
									sfeNode.addAttribute( QNDefs.c_AttrAuthor, rStr.getString() );
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrBrnch );
									sfeNode.addAttribute( QNDefs.c_AttrBrnch, rStr.getString() );
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrCmnt );
									sfeNode.addAttribute( QNDefs.c_AttrCmnt, rStr.getString() );									
		
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrDateTime );
									sfeNode.addAttribute( QNDefs.c_AttrDateTime, rStr.getString() );
									
									val = m_xDB.getAttrVal( rUid, QNDefs.c_AttrLbl ).getString();
									
									if( val.length() > 0 ) {
									
										sfeNode.addAttribute( QNDefs.c_AttrLbl, rStr.getString() );
									}									
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrName );
									sfeNode.addAttribute( QNDefs.c_AttrName, rStr.getString() );
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrPath );
									sfeNode.addAttribute( QNDefs.c_AttrPath, rStr.getString() );										
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrRel );
									sfeNode.addAttribute( QNDefs.c_AttrRel, rStr.getString() );
									
									rStr = m_xDB.getAttrVal( rUid, QNDefs.c_AttrSect );
									sfeNode.addAttribute( QNDefs.c_AttrSect, rStr.getString() );
									
									val = m_xDB.getAttrVal( rUid, QNDefs.c_AttrSrcSrv ).getString();
									
									if( val.length() > 0 ) {
									
										sfeNode.addAttribute( QNDefs.c_AttrSrcSrv, rStr.getString() );
									}								
								}
							}
						}
					}
				}
			}				
		}
		catch( Exception excp ) {
		
			res.setRsltByExcp( excp );
			setRsltStat( res );
		}	
		
		return res;
	}
	
	/**
	 * Append a solution to the list.
	 * @param p_UIDPR
	 * @param p_RightStat The expected status
	 * @return
	 */
	public Rslt appSol( String p_UidPR, String p_RightStat ) {		
		
		Rslt res = new Rslt( true );

		RsltXMLNode sprNode;

		if( m_slLstNode == null ) {
		
			res.setInError(  "Solution list is not prepared." );
		}
		
		if( res.checkRslt(  m_xDoc ) ) {
			
			sprNode = m_slLstNode.appNode( QNDefs.c_NodeShpPRRef  );
			
			res = bldSol( sprNode, p_UidPR, p_RightStat );
		}
		
		return res;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getRel() {
		
		RsltString res =  m_xDoc.getNodeVal( "ShpDoc/@ShipRel" );
		
		return res.getString();
	}

	/**
	 * 
	 * @return
	 */
	public String getShpDate() {
		
		RsltString res =  m_xDoc.getNodeVal( "ShpDoc/@DateTimeShip" );
		
		return res.getString();
	}
	
	/**
	 * Prepares the document.
	 */
	public void prepShpLstDoc() {
		
		m_xDoc = new RsltXMLDoc( "", QNDefs.c_NodeShpDoc, QNDefs.c_ShpLstDTD, null );
	}
	
	/**
	 * 
	 * @return The UID.
	 */
	public RsltString save() {
		
		RsltString UID;

		UID = m_xDB.importXML( m_xDoc.m_xDoc );
			
		if( !checkRslt( UID ) ) {
			
			UID.addRsltAddInfo( "'ShpDocBld.save(..)' failed." );
		}
		
		return UID;
	}
}
