package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.FixRepStat;
import RTtools.QNDocMan;

import com.qanavigation.Basics.BTools;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.Basics.SetList;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * View Fix Object
 *
 */
public class VFixObj extends FixObj {
	
	public boolean m_docNotFound;
	public boolean m_roleIsYours;	
	
	public int m_FixCount;
	
	public String m_hrefTail;
	public String m_notify;
	public String m_stat;
	public String m_ticket;
	public String m_title;
	public String m_qStr;

	public FixRepStat m_statObj;
	
	public QNDocMan m_qnDm;
	
	/**
	 * 
	 * @param p_srvl
	 * @param p_request
	 * @param p_dBacc
	 */
	public VFixObj(HttpServlet p_srvl, HttpServletRequest p_request, QNDBacc2 p_dBacc) {

		super( p_srvl, p_request, p_dBacc );
		
		m_qnDm = new QNDocMan( p_dBacc.m_DB, "Fix" );
		
		initMe();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "VFixObj", "VCRRepObj", "", "" );
		}
	}
	
	// ----------------------
	private void initMe() {
		
		m_docNotFound = false;
		m_roleIsYours = false;
		
		m_FixCount = 0;
		
		m_hrefTail = "";
		m_notify = "";
		m_stat = "";
		m_ticket = "";
		m_title = "";
		m_qStr = "";	
		
		m_statObj = null;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getFixAuthor() {
		
		String val;
	
		val = m_xDB.getAttrVal( m_UID.getString(), QNDefs.c_AttrAssignd ).getString();
		
		return val;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getFixDesc() {
		
		String val;
	
		val = m_xDB.getNodeValByParent( QNDefs.c_NodeDesc, m_UID.getString() ).getString();
		
		return val;
	}
	
	/**
	 * 
	 * @return
	 */
	public String getFixImp() {
	
		
		String val;
	
		val = m_xDB.getNodeValByParent( "FixImp", m_UID.getString() ).getString();
		
		return val;
	}	
	
	/**
	 * 
	 * @return
	 */
	public String getFixTstReq() {

		String val;
	
		val = m_xDB.getNodeValByParent( "TestReq", m_UID.getString() ).getString();
		
		return val;
	}
	
	/**
	 * Provides the list of fixes, ready for display.
	 * @return
	 */
	public String getFixLstPrepd() {

		int i;

		SetList uidLst;

		String html = "";
		
		String aUID;
		String val;
		
		uidLst = m_xDB.getUIDLstByParent( QNDefs.c_NodeFixLst, m_UID.getString() );
		
		if( uidLst.size() > 0 ) {

			aUID = uidLst.get( 0 );

			uidLst = m_xDB.getUIDLstByParent( QNDefs.c_NodeFixEnt, aUID );

			m_FixCount = uidLst.size();

//html += "<tr><td>" + m_FixCount + "</td></tr>";

			for( i = 0; i < m_FixCount; i++ ) {

				aUID = uidLst.get( i );

				html += "<tr>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrDateTime ).getString();

				html += "<td><input name=\"FixDate" + i + "\" size=\"8\" value=\"" + BTools.getDateFromISODateTime( val ) + "\" /></td>";

				html += "<td><input name=\"FixTime" + i + "\" size=\"4\" value=\"" + BTools.getTimeFromISODateTime( val ) + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrAuthor ).getString();
				html += "<td><input name=\"FixAuth" + i + "\" size=\"10\" value=\"" + val + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrPath ).getString();
				html += "<td><input name=\"FixPath" + i + "\" size=\"40\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrName ).getString();
				html += "<td><input name=\"FixFile" + i + "\" size=\"20\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrBrnch ).getString();
				html += "<td><input name=\"FixBranch" + i + "\" size=\"14\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrRel ).getString();
				html += "<td><input name=\"FixRel" + i + "\" size=\"5\" value=\"" + val + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrSect ).getString();
				html += "<td><input name=\"FixSect" + i + "\" size=\"20\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

				val = m_xDB.getAttrVal( aUID, QNDefs.c_AttrCmnt ).getString();			
				html += "<td><input name=\"FixCmnt" + i + "\" size=\"20\" value=\"" + val + "\" title=\"" + val + "\" /></td>";
				
				html += "<td>" + i + "<button id=\"DelFixBut" + i + "\" type=\"button\" onClick=\"delFixLine( this.id ); \">" + m_resBndl.getString( "blblDel" ) + "</button></td>";

				html += "</tr>";
			}
/*
for( i = m_FixCount; i < 20; i++ ) {

	aUID = "X" + i;

	html += "<tr>";

	val = "2009-08-11T11:12:13";

	html += "<td><input name=\"FixDate" + i + "\" size=\"8\" value=\"" + BTools.getDateFromISODateTime( val ) + "\" /></td>";

	html += "<td><input name=\"FixTime" + i + "\" size=\"4\" value=\"" + BTools.getTimeFromISODateTime( val ) + "\" /></td>";

	val = "Gen";
	html += "<td><input name=\"FixAuth" + i + "\" size=\"10\" value=\"" + val + "\" /></td>";

	val = "/Path" + i;
	html += "<td><input name=\"FixPath" + i + "\" size=\"40\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

	val = "File" + i;
	html += "<td><input name=\"FixFile" + i + "\" size=\"20\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

	val = "Brnch"  + i;
	html += "<td><input name=\"FixBranch" + i + "\" size=\"14\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

	val = "Rel" + i;
	html += "<td><input name=\"FixRel" + i + "\" size=\"5\" value=\"" + val + "\" /></td>";

	val = "Sect" + i;
	html += "<td><input name=\"FixSect" + i + "\" size=\"20\" value=\"" + val + "\" title=\"" + val + "\" /></td>";

	val = "Cmnt" + i;			
	html += "<td><input name=\"FixCmnt" + i + "\" size=\"20\" value=\"" + val + "\" title=\"" + val + "\" /></td>";
	
	html += "<td>" + i + "<button id=\"DelFixBut" + i + "\" type=\"button\" onClick=\"delFixLine( this.id ); \">" + m_resBndl.getString( "blblDel" ) + "</button></td>";

	html += "</tr>";
}*/
		}
		
		return html;
	}

	// ------------------------
	private RsltString handleSave(){
		
		RsltString rStr = new RsltString();
		
		rStr.setInError( "Not Implemented" );
		
		return rStr;
	}
	
	/**
	 * 
	 * @return
	 */
	public Rslt initObj() {
		
		String title;
		String txt;
		
		String UIDstr = "";
		
		RsltString rVal;
		
		Rslt res = new Rslt( true );
		
		// Saving a new report
		if( m_sTools.isExpVal( "QNA", "IssFix" ).isOK() ) {

			m_stat = m_sTools.getStrVal( "FixStat" );
			
			//FixRepStat statObj = new FixRepStat( m_stat );
		
			rVal = handleSave( );
			
			m_UID = rVal;
			
			UIDstr = rVal.getString();
			
			if( res.checkRslt( rVal ) ) {	

				title = m_resBndl.getString( "lblDocChg" );
				txt =  SFormatter.format( m_resBndl.getString( "msgDocChgBy" ), SFormatter.encodeHTML( m_User ) );
				m_fxb.addLogX( m_UID.getString(), m_User, title, txt, "", "" );
			}
			
			//doMail = isSub; 

	//dStr += "<p>" + res.getRsltFinalMsg() + " " + res.getRsltStatVal() + "</p>";		
			
			if( res.isOK() ) {
				
				UIDstr = m_UID.getString();

				m_qStr = "VQANavDoc?QNA=ViewFix&UID=" + UIDstr;
				m_hrefTail = "?QNA=ViewFix&UID=" + UIDstr;
			}
		}
		else {
			
			m_UID = m_sTools.getVal( "UID" );
			
			UIDstr = m_UID.getString();
			
			res = m_qnDm.chkDoc( UIDstr );
			
			if( res.isInStat( RsltStatVal.isEmpty ) ) {
			
				res.setOK();
				m_docNotFound = true; 
			}
			else {
				
				m_stat = m_qnDm.getDocStat( UIDstr ).getString();
				
				if( m_sTools.isExpVal( "QNA", "ViewFix" ).isOK() ) {

					m_qStr = "VQANavDoc?" + m_sTools.m_Req.getQueryString();
				}
			}
		}
		
		m_statObj = new FixRepStat( m_stat );
		
		if( res.isOK() && !( m_docNotFound )  ) {

			m_ticket = m_qnDm.m_xDB.getAttrVal( UIDstr, "Ticket" ).getString();
			m_title = m_qnDm.m_xDB.getAttrVal( UIDstr, "Title" ).getString();
			
			m_roleIsYours = m_uRTool.isYours( UIDstr );

		}
		
		if( res.isOK() ) {
			
			m_notify = "notify( \"FixIssOK\" );";
		}
		
		return res;
	}	

}
