// QANav Report Tracker Copyright 2008 -2009 Ronald D. Grindle

package RTObj;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;

import RTtools.QNDocMan;
import RTtools.TRStat;

import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.SFormatter;
import com.qanavigation.QNservices.QNDBacc2;
import com.qanavigation.QNservices.QNDefs;

/**
 * Technical Report View Object
 *
 */
public class VTRRepObj extends TRRepObj {

	public boolean m_statIsSub;
	public boolean m_docNotFound;
	public boolean m_roleIsInYGrp;
	public boolean m_roleIsYours;	
	
	public String m_hrefTail;
	public String m_notify;
	public String m_stat;
	public String m_ticket;
	public String m_title;
	public String m_qStr;	

	public TRStat m_statObj;
	
	public QNDocMan m_qnDm;
	
	/**
	 * 
	 * @param p_Request
	 * @param p_dBAcc
	 */
	public VTRRepObj( HttpServlet p_Srvl, HttpServletRequest p_Request, QNDBacc2 p_dBAcc ) {

		super( p_Srvl, p_Request, p_dBAcc );
		
		m_qnDm = new QNDocMan( p_dBAcc.m_DB, "ProbReport" );
		
		initMe();
		
		if( notOK() ) {
			
			addRsltAddFailInfo( "VTRRepObj", "VTRRepObj", "", "" );
		}		
	}
	
	// ----------------------
	private void initMe() {
		
		m_statIsSub = true;
		m_docNotFound = false;
		m_roleIsInYGrp = false;
		m_roleIsYours = false;		
		
		m_hrefTail = "";
		m_notify = "";
		m_stat = "";
		m_ticket = "";
		m_title = "";
		m_qStr = "";	
		
		m_statObj = null;
	}
	
	/**
	 * 
	 * @return
	 */
	public Rslt initObj() {
		
		String txt;
		
		RsltString rVal;
		
		String UIDstr = "";
		
		Rslt res = new Rslt( true );
		
		// Saving a new report
		if( m_sTools.isExpVal( "QNA", "IssProb" ).isOK() ) {

			m_stat = m_sTools.getStrVal( "ProbStat" );
			
			TRStat statObj = new TRStat( m_stat );
			
			m_statIsDraft = statObj.isDraft();
			
			m_statIsSub = statObj.isSub();
			
			rVal = handleSave( m_statIsDraft, m_statIsSub );
			
			m_UID = rVal;
			
			UIDstr = rVal.getString();
			
			if( res.checkRslt( rVal ) ) {	
				
				if( !( m_statIsDraft || m_statIsSub ) ) {
					
					txt =  SFormatter.format( m_resBndl.getString( "msgDocChgBy" ), SFormatter.encodeHTML( m_User ) );
					m_trb.appProcLogX( m_UID.getString(), txt );
				}
			}
			
			//doMail = isSub; 
			
	//dStr += "<p>" + res.getRsltFinalMsg() + " " + res.getRsltStatVal() + "</p>";		
			
			if( res.isOK() ) {

				m_qStr = "VQANavDoc?QNA=" + QNDefs.c_QNAViewTR + "&UID=" + UIDstr;
				m_hrefTail = "?QNA=" + QNDefs.c_QNAViewTR + "&UID=" + UIDstr;
			}
		}
		else {
			
			m_UID = m_sTools.getVal( "UID" );
			
			UIDstr = m_UID.getString();
			
			res = m_qnDm.chkDoc( m_UID.getString() );
			
			if( res.isInStat( RsltStatVal.isEmpty ) ) {
			
				res.setOK();
				m_docNotFound = true; 
			}
			else {
				
				if( m_sTools.isExpVal( "QNA", QNDefs.c_QNAViewTR ).isOK() ) {

					m_qStr = "VQANavDoc?" + m_sTools.m_Req.getQueryString();
				}
			}
		}
		
		if( res.isOK() && !( m_docNotFound )  ) {

			m_ticket = m_qnDm.m_xDB.getAttrVal( UIDstr, "Ticket" ).getString();
			m_title = m_qnDm.m_xDB.getAttrVal( UIDstr, "Title" ).getString();
			
			m_roleIsYours = m_uRTool.isYours( UIDstr );
			
			m_roleIsInYGrp = m_uRTool.isTRInYGrp( UIDstr );
			
			rVal = m_qnDm.getDocStat( m_UID.getString() );
			m_statObj = new TRStat( rVal.getString() );

			//m_assGroup = m_uGroup;

			//m_AssgnLst = uTool.getLst4Assgn( assGroup );
			
			/*
			if( isDpl ) {

				QNDocLstr docLstr = new QNDocLstr( dBAcc.m_DB );
				// getActiveShpDocLst
				m_ShpDocLst = docLstr.getShpDocLst( "", "" );
			}
			*/
		}
		
		if( res.isOK() ) {
			
			m_notify = "notify( \"ProbIssOK\" );";
		}
		
		return res;
	}
}
