package RTtools;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;

import javax.servlet.http.HttpServletRequest;

import com.qanavigation.Basics.RsltLst;
import com.qanavigation.Basics.RsltStatVal;

public class RTDataList {
	
	private HttpServletRequest m_req;
	private String m_dPth;
	
	/**
	 * 
	 * @param p_Req
	 */
	public RTDataList( HttpServletRequest p_Req ) {
		
		m_req = p_Req;
		
		m_dPth = "data";
	}
	
	/**
	 * 
	 * @param p_fileName
	 * @return
	 */
	public RsltLst<String> getLst( String p_fileName ) {
		
		RsltLst<String> rLst = new RsltLst<String>();
		
		BufferedReader br;
		DataInputStream dis;
		FileInputStream fstream;		
		
		int p1, p2;
		
		String line;
		String pth;
	
	    try {
	    	
			pth = m_req.getSession().getServletContext().getRealPath( m_dPth );
			
			p1 = pth.lastIndexOf( "\\" );
			p2 = pth.lastIndexOf( "/" );
		
			if( p1 > p2 ) {
				
				pth += "\\";
			}
			else {
			
				pth += "/";
			}	    	
		
			pth += p_fileName;
			
			fstream = new FileInputStream( pth );
			
			dis = new DataInputStream( fstream );
			br = new BufferedReader( new InputStreamReader( dis ) );
	
	    	line = br.readLine();
	    	
	    	while( line != null ) {
	    		
	    		rLst.add( line );
	    		
	    		line = br.readLine();
	    	}

	    	br.close();			
			
	    	dis.close();
	    	fstream.close();
	    	
	    	if( rLst.size() < 1 ) {
	    		
	    		rLst.setRsltStat( RsltStatVal.isEmpty );
	    	}
	    	else {
	    		
	    		rLst.setOK();
	    	}
	    } catch( Exception excp ){
	    	
	    	
	    	rLst.setRsltByExcp( excp );
	    	rLst.addRsltAddInfo( "'" + p_fileName + "' could not be loaded." );
	    }
		
		return rLst;
	}
	
	/**
	 * 
	 * @param p_fileName
	 * @return Propety list (key, value)
	 */
	public RsltLst<String[]> getPropLst( String p_fileName ) {
		
		RsltLst<String[]> rLst = new RsltLst<String[]>();
		
		BufferedReader br;
		DataInputStream dis;
		FileInputStream fstream;		
		
		int p1, p2, p;
		
		String line;
		String pth;
		
		String[] row;
	
	    try {
	    	
			pth = m_req.getSession().getServletContext().getRealPath( m_dPth );
			
			p1 = pth.lastIndexOf( "\\" );
			p2 = pth.lastIndexOf( "/" );
		
			if( p1 > p2 ) {
				
				pth += "\\";
			}
			else {
			
				pth += "/";
			}	    	
		
			pth += p_fileName;
			
			fstream = new FileInputStream( pth );
			
			dis = new DataInputStream( fstream );
			br = new BufferedReader( new InputStreamReader( dis ) );
	
	    	line = br.readLine();
	    	
	    	while( line != null ) {
	    		
	    		row = new String[2];
	    		
	    		p = line.indexOf( "=" );
	    		
	    		row[0] = line.substring( 0, p -1 ).trim();

	    		row[1] = line.substring( p + 1 ).trim();
	    		
	    		rLst.add( row );
	    		
	    		line = br.readLine();
	    	}

	    	br.close();
			
	    	dis.close();
	    	fstream.close();
	    	
	    	if( rLst.size() < 1 ) {
	    		
	    		rLst.setRsltStat( RsltStatVal.isEmpty );
	    	}
	    	else {
	    		
	    		rLst.setOK();
	    	}
	    } catch( Exception excp ){
	    	
	    	
	    	rLst.setRsltByExcp( excp );
	    	rLst.addRsltAddInfo( "'" + p_fileName + "' could not be loaded." );
	    }
		
		return rLst;
	}	
}
