package RTtools;

import java.util.ArrayList;

import com.qanavigation.Basics.IRslt;
import com.qanavigation.Basics.Rslt;
import com.qanavigation.Basics.RsltStatVal;
import com.qanavigation.Basics.RsltString;
import com.qanavigation.Basics.RsltTable;
import com.qanavigation.DBacc.DBacc2;
import com.qanavigation.XMLDB.XMLDB;

public class TestRTT {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Rslt res = new Rslt( true );
		
		XMLDB xDB;
		
		DBacc2 db = new DBacc2( "QNdata", "localhost", "QANuser", "QANPass");
		
		if( res.checkRslt( db ) ) {
		
			xDB = new XMLDB( db, "localhost" );
		
			if( res.checkRslt( xDB )  ) {
				
				testUserTool1( xDB );
			}
		}
		
		issueErrors( res );
		
		db.close();
	}
	
	static void testUserTool1( XMLDB xDB ) {
		
		RsltString rs;
		RsltTable rt;
		
		UserSrvcTool ut = new UserSrvcTool( xDB );
		issueErrors( ut );
		
		rs = ut.getAss4NewCR();
		System.out.println( rs.getString() );
		issueErrors( rs );
		
		System.out.println( "" );
		System.out.println( "getByRoleApplRel" );
		rs = ut.getByRoleApplRel( "sp", "ba", "WITA", "");
		System.out.println( rs.getString() );
		issueErrors( rs );
		
		System.out.println( "" );
		System.out.println( "getByRoleApplRel" );
		rs = ut.getByRoleApplRel( "sp", "ba", "BL-Wneu", "");
		System.out.println( rs.getString() );
		issueErrors( rs );
		
		System.out.println( "" );
		System.out.println( "getByRoleApplRel, 1.250" );
		rs = ut.getByRoleApplRel( "co", "dev", "BL-Wneu Entwicklung", "01.250");
		System.out.println( rs.getString() );
		issueErrors( rs );		
		
		System.out.println( "" );
		System.out.println( "getByRoleApplRel, 1.100" );
		rs = ut.getByRoleApplRel( "co", "dev", "BL-Wneu Entwicklung", "01.100");
		System.out.println( rs.getString() );
		issueErrors( rs );	
		
		System.out.println( "" );
		System.out.println( "getAss4NewTR, 1.100" );		
		rs = ut.getAss4NewTR( "BL-Wneu Entwicklung", "01.100.01" );
		System.out.println( rs.getString() );
		issueErrors( rs );

		System.out.println( "" );
		System.out.println( "getAss4NewTR, 1.250" );		
		rs = ut.getAss4NewTR( "BL-Wneu Entwicklung", "01.250-33" );
		System.out.println( rs.getString() );
		issueErrors( rs );		
		
	}
	
	// -------------------------------------------
	static void issueErrors( IRslt p_Rslt ) {

		int i, x;
		ArrayList<String> addInfo;
		
		if( p_Rslt.notOK() ) {

			addInfo = p_Rslt.getRsltAddInfo();
	
			System.out.println( "Messages:" );
	
			x = addInfo.size();
	
			for( i = 0; i < x; ++i ) {
	
				System.out.println( (String)addInfo.get( i ) );
			}
			
			System.out.println( "Status: " + RsltStatVal.label[ p_Rslt.getRsltStatVal() ] );
		}
	}	

}
