//package xsl;


import java.io.*;
import java.util.regex.*;
import java.util.*;

/**
 * @author RDG
 *
 */
public class XSLlocaler {

	private static Pattern m_Pattern;
	//private static ResourceBundle m_ResBndl;
	private static PropertyResourceBundle m_ResBndl;
		
	public static void main(String[] args) {

		int rc;

		rc = 0;
		
		if( args.length < 3 ) {
			
			System.out.println( "Replace locale labels. Label: #%lblAbcd%#" );
			System.out.println( "Specify <SourceName> <TargetName> <Property>" );

			rc = -1;
			
			System.exit( rc );
		}
		
		try {
			
			String srcName = args[0];
			String trgtName = args[1];
			String propName = args[2];
						
			String line;
				
			FileInputStream resStrm = new FileInputStream( propName );
			
			m_ResBndl = new PropertyResourceBundle( resStrm );
			
			//ResourceBundle m_ResBndl = ResourceBundle.getBundle( "QNLabels", loc );
			
			m_Pattern = Pattern.compile( "#%.+?%#" );
	
			FileInputStream inStrm = new FileInputStream( srcName );
			FileOutputStream outStrm = new FileOutputStream( trgtName );

			BufferedReader buffR = new BufferedReader(new InputStreamReader( inStrm ));
			BufferedWriter buffW= new BufferedWriter(new OutputStreamWriter( outStrm ));

			System.out.println( "Generating '" + trgtName + "'" );

			while ( (line = buffR.readLine() ) != null ) {
				
				line = dLbl( line );
				
//				System.out.println( line );
				
				buffW.write( line + "\r\n" );
			}

			buffR.close();
			buffW.close();
		}
		catch( Exception exc ) {

			rc = -1;
			
			handleExc( exc );						
		}

		System.out.println( "Done." );

		System.exit( rc );
	}
	
	private static String dLbl( String p_Line ) {
		
		String resStr = p_Line;
		
		String tag;
		String rpl;
		
		Matcher matcher = m_Pattern.matcher( p_Line );
		
		while( matcher.find() ) {
			
			tag = matcher.group();
			
			tag = tag.substring( 2, tag.lastIndexOf( "%#" ) );
			
			rpl = m_ResBndl.getString( tag ); 
			
			resStr = resStr.replaceFirst( matcher.group(), rpl );			
		}
		
		return resStr;
	}
	
	private static void handleExc( Exception p_Excp ) {
		
		int i, x;
		Throwable cause;
		StackTraceElement[] ste;
		String msg;	
		
		msg = p_Excp.getMessage();
		
		if( null != msg ) {
			
			System.out.println( "Msg: '" +  msg + "'" );	
		}
		
		System.out.println( "Excp: '" + p_Excp.toString() + "'" );
	
		cause = p_Excp.getCause();
		
		if( null != cause ) {
			
			System.out.println( "Cause: '" + p_Excp.getCause().toString() + "'" );
		}
		
		ste = p_Excp.getStackTrace();
		
		x = ste.length;
		
		if( x > 0 )  {
			
			System.out.println( "Stack Trace:" );
		}
		
		for( i = 0; i < x; ++i ) {
			
			System.out.println( "  " + ste[i].toString() );
		}
	}
}
